/******************************************************************************
 *
 *                Copyright (c) 2017-2019 by Löwenware Ltd
 *             Please, refer LICENSE file for legal information
 *
 ******************************************************************************/

/**
 * @file mod-feedback.h
 * @author Ilja Kartašov <ik@lowenware.com>
 * @brief AISL feedback module header file
 *
 * @see https://lowenware.com/aisl/
 */

#ifndef AISLX_MOD_FEEDBACK_H_6CC516E4_A7F2_4A9D_B467_75DCF6F58108
#define AISLX_MOD_FEEDBACK_H_6CC516E4_A7F2_4A9D_B467_75DCF6F58108

#include <mods/interface.h>


struct aislx_mod_feedback_cfg
{
	const char        *end_point;
	const char        *mail_subject;
	const char        *mail_from;
	const char        *mail_to;
	const char        *name_email;
	const char        *name_msg;
	const char        *smtp_host;
	const char        *smtp_user;
	const char        *smtp_pass;
	uint16_t           smtp_port;
};

typedef struct aislx_mod_feedback_cfg * aislx_mod_feedback_cfg_t;


struct aislx_mod_feedback
{
	struct aislx_mod   root;

	const char        *mail_subject;
	const char        *mail_from;
	const char        *name_email;
	const char        *name_msg;
	const char        *smtp_host;
	const char        *smtp_user;
	const char        *smtp_pass;
	uint16_t           smtp_port;

	uint16_t           name_email_length;
	uint16_t           name_msg_length;
};


typedef struct aislx_mod_feedback * aislx_mod_feedback_t;


aisl_status_t
aislx_mod_feedback_init(aislx_mod_feedback_t mod,
                        aislx_mod_feedback_cfg_t cfg);


void
aislx_mod_feedback_release(aislx_mod_feedback_t mod);

#endif /* !AISLX_MOD_FEEDBACK_H */
